package io.accumulatenetwork.sdk.generated.query;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("MultiResponse")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class MultiResponse implements Marshallable {
	private String type;
	private String[] items;
	private long start;
	private long count;
	private long total;

    //
	public String getType() {
	    return type;
	}
	public void setType(final String value) {
	    this.type = value;
	}

	public MultiResponse type(final String value) {
	    setType(value);
	    return this;
	}
	public String[] getItems() {
	    return items;
	}
	public void setItems(final String[] value) {
	    this.items = value;
	}

	public MultiResponse items(final String[] value) {
	    setItems(value);
	    return this;
	}
	public long getStart() {
	    return start;
	}
	public void setStart(final long value) {
	    this.start = value;
	}

	public MultiResponse start(final long value) {
	    setStart(value);
	    return this;
	}
	public long getCount() {
	    return count;
	}
	public void setCount(final long value) {
	    this.count = value;
	}

	public MultiResponse count(final long value) {
	    setCount(value);
	    return this;
	}
	public long getTotal() {
	    return total;
	}
	public void setTotal(final long value) {
	    this.total = value;
	}

	public MultiResponse total(final long value) {
	    setTotal(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.type == null || this.type.length() == 0)) {
            marshaller.writeString(1, this.type);
        }
        if (!(this.items == null || this.items.length == 0)) {
            marshaller.writeString(2, this.items);
        }
        marshaller.writeUint(3, this.start);
        marshaller.writeUint(4, this.count);
        marshaller.writeUint(5, this.total);
        return marshaller.array();
    }
}
